FixedLengthUtil::FixedLengthIterator Class Reference

The FixedLengthIterator class allows fixed-length data sources to be iterated on a record basis. The source of the input data is an AbstractLineIterator object or an InputStream. More...

Inheritance diagram for FixedLengthUtil::FixedLengthIterator:
[legend]

## Public Member Functions

| constructor (Qore::AbstractLineIterator li, hash< auto > spec, *hash< auto > opts)
| Creates the FixedLengthIterator in single-type mode with general line iterator to read and an option hash. More...
| constructor (Qore::InputStream input, string encoding="UTF-8", hash< auto > spec, *hash< auto > opts)
| Instantiates the FixedLengthIterator object from an InputStream. More...
| constructor (Qore::StringInputStream input, hash< auto > spec, *hash< auto > opts)
| Instantiates the FixedLengthIterator object from a StringInputStream. More...
Public Member Functions inherited from FixedLengthUtil::FixedLengthAbstractIterator
bool | checkTransition (*string from, *string to)
| A verification function to be called for each line. This method can be overridden to achieve a begin-to-end validation of the whole input file. More...
| constructor (AbstractLineIterator li, hash< auto > spec, *hash< auto > opts)
| Instantiates the FixedLengthAbstractIterator object. More...
*hash< auto > | getValue ()
| Returns the current record as a hash. More...
bool | identifyRecord (list< auto > rec_rule, string input_line)
| Attempts to identify a single record.
string | identifyType (string input_line)
| Identify a fixed-length line type using identifyTypeImpl(), that may be overridden if necessary. More...
*string | identifyTypeImpl (string input_line)

Identify a fixed-length line type, given the raw line string. This method performs a lookup to a precalculated table based on line lengths (see constructor()). In case different criteria are needed, eg. when two line types in a spec have the same length and no unique resolving rule are specified, this method needs to be overridden, and will throw an exception, because the precalculated mapping will be empty. More...

bool | next ()
| Moves the current line / record position to the next line / record; returns False if there are no more lines to iterate. More...
auto | transform (auto value, hash< auto > type)
| parses the input value based on global configuration and the current field definition
Public Member Functions inherited from FixedLengthUtil::FixedLengthBase
| constructor (hash< auto > m_specs, *hash< auto > m_opts)
| Creates the object from the record specifications.
*hash< string, AbstractDataField > | getRecordType ()
| Returns the description of the record type, if any.

## Additional Inherited Members

Static Protected Member Functions inherited from FixedLengthUtil::FixedLengthAbstractIterator
static *hash< auto > | checkOptions (*hash< auto > opts)
| Validate and prepare global fixed-length options. More...
Protected Attributes inherited from FixedLengthUtil::FixedLengthAbstractIterator
hash | m_resolve_by_length
| hash of type without rule, i.e.potentially conflicting records; key = record length, value = list of no-rule type names
Protected Attributes inherited from FixedLengthUtil::FixedLengthBase
const | GlobalOptionMap = ...
| Translates from global options to data provider options.
*hash< auto > | m_opts
| Global input or output options.
hash< auto > | m_specs
| The record specifications.

## Detailed Description

The FixedLengthIterator class allows fixed-length data sources to be iterated on a record basis. The source of the input data is an AbstractLineIterator object or an InputStream.

## Member Function Documentation

## constructor() [1/3]

FixedLengthUtil::FixedLengthIterator::constructor | ( | Qore::AbstractLineIterator | li,
|  | hash< auto > | spec,
|  | *hash< auto > | opts
| ) |  |

Creates the FixedLengthIterator in single-type mode with general line iterator to read and an option hash.

Parameters

  li | line iterator of fixed-length file to read
  spec | Fixed-length line specification; see Specification Hash for more information
  opts | Global options; see Global Options for more information

## constructor() [2/3]

FixedLengthUtil::FixedLengthIterator::constructor | ( | Qore::InputStream | input,
|  | string | encoding = `"UTF-8"`,
|  | hash< auto > | spec,
|  | *hash< auto > | opts
| ) |  |

Instantiates the FixedLengthIterator object from an InputStream.

Example:
  const Specs = {
  "type1": {
  "col1": {"length": 5, "type": "int"},
  "col2": {"length": 2, "type": "string"},
  },
  "type2": {
  "col3": {"length": 1, "type": "string"},
  "col4": {"length": 3, "type": "string"},
  "col5": {"length": 8, "type": "date", "format": "DDMMYYYY", "timezone": "Europe/Prague"},
  },
  };
  const GlobalOptions = {
  "encoding" : "UTF-8",
  "eol" : "\n",
  "ignore_empty": True,
  "timezone" : "Europe/Prague", # used if not overridden in a date field specification
  };
  BinaryInputStream input(binary("00001AV\n00002BN\00003CZ\n"));
  FixedLengthIterator i(input, "UTF-8", specs, global_options);
  while (i.next()) {
  operation_with_hash(i.getValue())
  }
  binary
  binary binary()

Parameters

  input | The InputStream providing input data to process
  encoding | the encoding of the input stream
  spec | Fixed-length line specification; see Specification Hash for more information
  opts | Global options; see Global Options for valid values

## constructor() [3/3]

FixedLengthUtil::FixedLengthIterator::constructor | ( | Qore::StringInputStream | input,
|  | hash< auto > | spec,
|  | *hash< auto > | opts
| ) |  |

Instantiates the FixedLengthIterator object from a StringInputStream.

Example:
  const Specs = {
  "type1": {
  "col1": {"length": 5, "type": "int"},
  "col2": {"length": 2, "type": "string"},
  },
  "type2": {
  "col3": {"length": 1, "type": "string"},
  "col4": {"length": 3, "type": "string"},
  "col5": {"length": 8, "type": "date", "format": "DDMMYYYY", "timezone": "Europe/Prague"},
  },
  };
  const GlobalOptions = {
  "encoding" : "UTF-8",
  "eol" : "\n",
  "ignore_empty": True,
  "timezone" : "Europe/Prague", # used if not overridden in a date field specification
  };
  StringInputStream input("00001AV\n00002BN\00003CZ\n");
  FixedLengthIterator i(input, Specs, GlobalOptions);
  while (i.next()) {
  operation_with_hash(i.getValue())
  }

Parameters

  input | The InputStream providing input data to process
  encoding | the encoding of the input stream
  spec | Fixed-length line specification; see Specification Hash for more information
  opts | Global options; see Global Options for valid values